package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

public class TestInstructor {

    @Test
    public void testImplementation() {
        // Given
        long id = 1234567;
        Instructor instructor = new Instructor(id);
        boolean expectedOutput = true;

        // When
        boolean actualOutput = instructor instanceof Teacher;

        // Then
        Assert.assertEquals(expectedOutput, actualOutput);
    }

    @Test
    public void testInheritance() {
        // Given
        long id = 1234567;
        Instructor instructor = new Instructor(id);
        boolean expectedOutput = true;

        // When
        boolean actualOutput = instructor instanceof Person;

        // Then
        Assert.assertEquals(expectedOutput, actualOutput);
    }

    @Test
    public void testTech() {
        // Given
        long id = 1234567;
        Instructor instructor = new Instructor(id);
        Student student = new Student(id);
        instructor.teach(student,60);
        double expectedOutput = student.getTotalStudyTime();

        // When
        double actualOutput = 60;

        // Then
        Assert.assertEquals(expectedOutput, actualOutput, 0.01);
    }

    @Test
    public void testLecture() {
        // Given
        long id = 1234567;
        Instructor instructor = new Instructor(id);
        long studentID = 2345678;
        Student student = new Student(studentID);
        long studentID2 = 3456789;
        Student student2 = new Student(studentID2);
        Student[] students = {student, student2};
        instructor.lecture(students, 120);
        double expectedOutput = students[0].getTotalStudyTime();

        // When
        double actualOutput = 60;

        // Then
        Assert.assertEquals(expectedOutput, actualOutput, 0.01);
    }
}
