package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

public class TestPeople {

    @Test
    public void testAdd() {
        // Given
        People people = new People();
        long id = 1234567;
        Person person = new Person(id);
        people.add(person);
        long id2 = 2345678;
        Person person2 = new Person(id2);
        people.add(person2);
        long id3 = 3456789;
        Person person3 = new Person(id3);
        people.add(person3);
        int expectedOutput = 3;

        // When
        int actualOutput = people.getCount();

        // Then
        Assert.assertEquals(expectedOutput, actualOutput);
    }

    @Test
    public void testRemoveByPerson() {
        // Given
        People people = new People();
        long id = 1234567;
        Person person = new Person(id);
        people.add(person);
        long id2 = 2345678;
        Person person2 = new Person(id2);
        people.add(person2);
        long id3 = 3456789;
        Person person3 = new Person(id3);
        people.add(person3);
        people.remove(person3);
        int expectedOutput = 2;

        // When
        int actualOutput = people.getCount();

        // Then
        Assert.assertEquals(expectedOutput, actualOutput);
    }

    @Test
    public void testRemoveById() {
        // Given
        People people = new People();
        long id = 1234567;
        Person person = new Person(id);
        people.add(person);
        long id2 = 2345678;
        Person person2 = new Person(id2);
        people.add(person2);
        long id3 = 3456789;
        Person person3 = new Person(id3);
        people.add(person3);
        people.remove(person3.getId());
        int expectedOutput = 2;

        // When
        int actualOutput = people.getCount();

        // Then
        Assert.assertEquals(expectedOutput, actualOutput, 0.01);
    }

    @Test
    public void testFindById() {
        // Given
        People people = new People();
        long id = 1234567;
        Person person = new Person(id);
        people.add(person);
        long id2 = 2345678;
        Person person2 = new Person(id2);
        people.add(person2);
        long id3 = 34556789;
        Person person3 = new Person(id3);
        people.add(person3);
        Person expectedOutput = person2;

        // When
        Person actualOutput = people.findById(id2);

        // Then
        Assert.assertEquals(expectedOutput, actualOutput);
    }

    @Test
    public void testGetArray() {
        // Given
        People people = new People();
        long id = 1234567;
        Person person = new Person(id);
        people.add(person);
        long id2 = 2345678;
        Person person2 = new Person(id2);
        people.add(person2);
        long id3 = 34556789;
        Person person3 = new Person(id3);
        people.add(person3);
        int expectedOutput = people.getCount();

        // When
        int actualOutput = people.getArray().length;

        // Then
        Assert.assertEquals(expectedOutput, actualOutput);
    }

    @Test
    public void testRemoveAll() {
        // Given
        People people = new People();
        long id = 1234567;
        Person person = new Person(id);
        people.add(person);
        long id2 = 2345678;
        Person person2 = new Person(id2);
        people.add(person2);
        long id3 = 34556789;
        Person person3 = new Person(id3);
        people.add(person3);
        int expectedOutput = people.getCount() - people.getCount();

        // When
        people.removeAll();
        int actualOutput = people.getCount();

        // Then
        Assert.assertEquals(expectedOutput, actualOutput);

    }
}
