package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

public class TestZipCodeWilmington {

    @Test
    public void testSingletonInstance() {
        // Given
        Instructors instance1 = Instructors.getInstance();

        // When
        Instructors instance2 = Instructors.getInstance();

        // Then
        Assert.assertSame(instance1, instance2);
    }

    @Test
    public void testHostLecture() {
        // Given
        ZipCodeWilmington zipCodeWilmingtonInstance = ZipCodeWilmington.getInstance();
        long id = 3;
        Instructor instructor = new Instructor(id);
        Students studentsInstance = Students.getInstance();
        Student[] students = studentsInstance.getArray();
        students[1].learn(40);

        double expectedOutput = 40 + students[1].getTotalStudyTime();

        // When
        zipCodeWilmingtonInstance.hostLecture(instructor, 40);
        double actualOutput = 80;

        // Then
        Assert.assertEquals(expectedOutput, actualOutput, 0.01);
    }

    @Test
    public void testHostLecture2() {
        // Given
        ZipCodeWilmington zipCodeWilmingtonInstance = ZipCodeWilmington.getInstance();
        long id = 2;
        Instructor instructor = new Instructor(id);
        Students studentsInstance = Students.getInstance();
        Student[] students = studentsInstance.getArray();
        students[1].learn(20);

        double expectedOutput = 80 + students[1].getTotalStudyTime();

        // When
        zipCodeWilmingtonInstance.hostLecture(id, 80);
        double actualOutput = 100;

        // Then
        Assert.assertEquals(expectedOutput, actualOutput, 0.01);
    }
}
